var invite_param = "", invite_array = new Array("","","")
var num_window = 0
var key_filter = "abcdefghijklmnopqrstuvwxyABCDEFGHIGKLMNOPQRSTUVWXYZ0123456789_-+."

function add_alert(file,noeud,invites)
{
	prefix_alert = noeud
	invite_param = invites
	type_w = "alert"
	getSVGObject(file, window_active)
}

function add_confirm(file,noeud,invites,num)
{
	prefix_confirm = noeud
	invite_param=invites
	num_window = num
	type_w = "confirm"
	getSVGObject(file, window_active)
}

function add_prompt(file,noeud,invites,num)
{
	prefix_prompt = noeud
	invite_param=invites
	num_window=num
	prompt_text=""
	type_w = "prompt"
	getSVGObject(file, window_active)
}

function window_active(doc_frag) 
{
	switch(type_w)
	{
			case "alert" :
				var node = svgdoc.getElementById(prefix_alert)
				break
			case "confirm" :
				var node = svgdoc.getElementById(prefix_confirm)
				break
			case "prompt" :
				var node = svgdoc.getElementById(prefix_prompt)
				break
				
	}
	node.appendChild (doc_frag)
	textes_init()
	language_init()
}

function language_init()
{
	switch(type_w)
	{
		case "alert" :
			svgdoc.rootElement.addEventListener("keypress",alert_tape,false)
			svgdoc.getElementById("alert_ok").firstChild.data = popup_message[0]
			break
		case "confirm" :
			svgdoc.rootElement.addEventListener("keypress",confirm_tape,false)
			svgdoc.getElementById("confirm_yes").firstChild.data = popup_message[1]
			svgdoc.getElementById("confirm_no").firstChild.data = popup_message[2]
			break
		case "prompt" :
			svgdoc.rootElement.addEventListener("keydown",prompt_down,false)
			svgdoc.rootElement.addEventListener("keypress",prompt_tape,false)
			prompt_pos = 0
			svgdoc.getElementById("prompt_header").firstChild.data = popup_message[3]
			svgdoc.getElementById("prompt_ok").firstChild.data = popup_message[4]
			svgdoc.getElementById("prompt_cancel").firstChild.data = popup_message[5]
			break
	}
}

function remove_window(noeud)
{
	var ou = svgdoc.getElementById(noeud)
	if (!ou.hasChildNodes)
		return
	var childs = ou.childNodes
	var nombre = childs.length
	for (var i = nombre - 1 ; i >= 0 ; i--)
	{
		child=childs.item(i)
		ou.removeChild (child)
	}
}

function textes_init()
{
	analyse_chaine()
	ecris_chaine()
}

function analyse_chaine()
{
	invite_array = invite_param.split("\n");
}

function ecris_chaine()
{
	for (var i = 0 ; i < 3 ; i++)
		svgdoc.getElementById('invite'+i.toString()).firstChild.data = invite_array[i]
}

function alert_tape(evt)
{
	var key = evt.charCode;
	if (!key)
		key = evt.keyCode
	if (key==13)
		close_alert(true)
}

function confirm_tape(evt)
{
	var key = evt.charCode;
	if (!key)
		key = evt.keyCode
	if (key==13) 
		close_confirm(true)
	if (key==27) 
		close_confirm(false)
}

function prompt_tape(evt)
{
	var key = evt.charCode;
	if (!key)
		key = evt.keyCode
	var str = svgdoc.getElementById("prompt_result").firstChild.data
	var add_space = false
	var max_prompt_name = 270
	var prompt_modify = false
	if (str == " ")
		str = ""
	switch(key)
	{	
		case 0 :
				break
		case 27:
				close_prompt(false)
				break
		case 13 :
				close_prompt(true)
				break
		case 8 :
				if (prompt_pos > 0)
				{
					if (prompt_pos > 1)
						var debut = str.substring(0 , prompt_pos - 1)
					else
						var debut = ""
					if (prompt_pos < str.length)
						str = debut + str.substring(prompt_pos , str.length)
					else
						str = debut
					prompt_pos -= 1
					prompt_modify = true
				}
				break
		default :
				caractere = String.fromCharCode(key)
				if (key_filter.indexOf(caractere) >= 0)
				{
					var new_str = str.substring(0 , prompt_pos) + caractere + str.substring(prompt_pos , str.length) 
					svgdoc.getElementById("prompt_result").firstChild.data = new_str
					if (svgdoc.getElementById("prompt_result").getComputedTextLength() <= max_prompt_name)
					{
						str = new_str
						prompt_pos += 1
						prompt_modify = true
						if (key == 32)
							add_space = true
					}
					else
						svgdoc.getElementById("prompt_result").firstChild.data = str
				}
				break
	}
	if (prompt_modify)
	{
		if (prompt_pos > 0)
		{
			svgdoc.getElementById("prompt_result").firstChild.data = str.substring(0 , prompt_pos)
			var str_length = svgdoc.getElementById("prompt_result").getComputedTextLength()
			if (add_space)
				str_length += 3 
		}
		else
			str_length = 0
		svgdoc.getElementById("prompt_result").firstChild.data = str
		var d = "M" + (22 + str_length).toString() + " 98v12"
		svgdoc.getElementById("prompt_cursor").setAttribute("d", d) 
	}
	evt.preventDefault() 
}

function prompt_down(evt)
{
	var key = evt.charCode;
	if (!key)
		key = evt.keyCode
	var prompt_modify = false
	var str = svgdoc.getElementById("prompt_result").firstChild.data
	switch(key)
	{	
		case 37 :
				prompt_pos -= 1
				if (prompt_pos < 0)
					prompt_pos = 0
				else
					prompt_modify = true
				break
		case 39 :
				prompt_pos += 1
				if (prompt_pos > str.length)
					prompt_pos = str.length
				else
					prompt_modify = true
				break
		case 127 :
				if (prompt_pos < str.length)
				{
					str = str.substring(0 , prompt_pos) + str.substring(prompt_pos  + 1, str.length)
					prompt_modify = true
				}
				break
		default :
				break
	}
	if (prompt_modify)
	{
		if (prompt_pos > 0)
		{
			svgdoc.getElementById("prompt_result").firstChild.data = str.substring(0 , prompt_pos)
			var str_length = svgdoc.getElementById("prompt_result").getComputedTextLength()
		}
		else
			var str_length = 0
		var d = "M" + (22 + str_length).toString() + " 98v12"
		svgdoc.getElementById("prompt_cursor").setAttribute("d", d) 
		svgdoc.getElementById("prompt_result").firstChild.data = str
	}
	evt.preventDefault() 
}

function close_alert(result)
{
	svgdoc.rootElement.removeEventListener("keypress",alert_tape,false)
	remove_window(prefix_alert);
}

function close_confirm(result)
{
	svgdoc.rootElement.removeEventListener("keypress",confirm_tape,false)
	remove_window(prefix_confirm)
	eval(prefix_confirm + "_use_confirm(result,num_window)")
}

function close_prompt(result)
{
	svgdoc.rootElement.removeEventListener("keydown",prompt_down,false)
	svgdoc.rootElement.removeEventListener("keypress",prompt_tape,false)
	var text_enter = svgdoc.getElementById('prompt_result').firstChild.data
	remove_window(prefix_prompt)
	eval(prefix_prompt + "_use_prompt(result,text_enter,num_window)")
}